#ifndef _POLYDRAW_H
#define _POLYDRAW_H

#include <vector>
#include <list>

#include <gtkmm/drawingarea.h>

#include "Vertex.h"
#include "Line.h"
#include "Polygon.h"
#include "Tool.h"


enum Tool_Mode { SelectPolys, LineTest, PolygonAdd, PolygonSub, CutPolys, DelPolys, GluePolys };

class PolyDraw : public Gtk::DrawingArea
{
public:
  PolyDraw();
  virtual ~PolyDraw();
	void setMode(Tool *t);

	std::list<Polygon *> polygons;
	std::list<Polygon *> selected_polygons;
	double size;

protected:
	Tool *tool;

  //Override default signal handler:
  virtual bool on_expose_event(GdkEventExpose* event);

	bool on_mouse_up( GdkEventButton *event );
	bool on_mouse_down( GdkEventButton *event );
	bool on_move( GdkEventMotion *event );

	void redraw();
};

#endif 
