#ifndef _POLYGONTOOL_H_
#define _POLYGONTOOL_H_

#include <list>
#include <gdk/gdkevents.h>
#include <cairomm/context.h>

#include "Vertex.h"
#include "Polygon.h"
#include "Tool.h"

class PolyDraw;

class PolygonTool : public Tool
{
public:
	PolygonTool(PolyDraw *pd);

	bool on_mouse_down(GdkEventButton *event);
	bool on_mouse_up(GdkEventButton *event);
	bool on_mouse_move(GdkEventMotion *event);

	bool redraw(Cairo::RefPtr<Cairo::Context>& cr);

protected:
	void subtractPolygonFromDrawArea(Polygon *newpoly);
	Polygon* constructPolygon();
	void eliminateZeroLengthEdges();
	virtual void finalize() = 0;

private:
	bool down;
	std::list<Vertex> construct;
};

#endif