#ifndef _SELECTTOOL_H_
#define _SELECTTOOL_H_

#include "Tool.h"

#include <gdk/gdkevents.h>
#include <cairomm/context.h>

#include "Vertex.h"

class PolyDraw;

class SelectTool : public Tool
{
public:
	SelectTool(PolyDraw *pd) : Tool(pd),down1(false),down3(false) {}
	~SelectTool();

	bool on_mouse_down(GdkEventButton *event);
	bool on_mouse_up(GdkEventButton *event);
	bool on_mouse_move(GdkEventMotion *event);

	bool redraw(Cairo::RefPtr<Cairo::Context>& cr);
private:
	bool down1, down3;

	bool selectPolygonAtPoint(const Vertex& point) const;
	bool deselectPolygonAtPoint(const Vertex& point) const;
};

#endif